-- To Do

-- allow double clicks to automatically send a card/stack to it's suit when valid ?

-- add "hints" 
	-- the system should look for and identify the first found legit move
	-- first, search all piles looking for a Top card that can go on it's suit's stack
	-- next, seach all piles looking for a Bottom card that can go on another pile's Top card
	-- check the chute's current card against it's suit's stack
	-- check the chute's current card against each pile's Top card
	-- if a valid move is found, display a blue semi-transparent arrow from the source to the destination (Arrow.lua class is already written)
	-- remove the arrow when the user clicks/mousedown on any pile or chute card.

-- complete deck images...
--	track down all of the needed source images

-- importing/use of custom decks
---------------------------------------------------------------------------------------------------------------------------------------------
-- Ring is just a simple solitaire game to pass the time when you're waiting on a raid or whatever
-- Initially, one card is dealt face up on each pile (the number of piles can be changed in the options)
-- Right clicking on the deck will turn over three cards at a time. Only the topmost face up card of the deck can be played. Once the topmost card is played, the next one down can be played until there are no more face up cards. If no more cards are face up, right click on the deck to turn over three more cards - if less than three cards are left in the deck they will all be flipped. Playing a card from the deck is not obligatory. Once the entire deck is face up, right clicking on the face up cards will flip the entire deck face down to cycle through them again.

-- Cards are played by dragging them either to a Ring Pile or to their suit stack. Cards can be played either on the ring on the next higher card of the matching suit or placed on their Suit Stack if they are higher than the card currently on theor Suit Stack or are the first card of their Suit Stack.
-- The highest card of a suit (a 9) can be played to any empty Ring Pile (playing to the empty pile is not obligatory, the player can choose to leave a pile empty until needed).
-- Only the bottommost and topmost cards in a stack will be visible (the bottommost card will only be partially visible). You can drag an entire stack by dragging the exposed portion of the bottommost card.  When dragging over a card, the card will have a light blue highlighted border if the card(s) being dragged can be dropped on that card/stack.
-- NOTE: Since the rotated piles have slightly quirky underlying outlines, you may have to drag over the edges of the card you are trying to drop on to get the highlight to show. The cards you are dragging will only be moved if the highlight is showing when you drop them, otherwise they return to their original location and you will have to drag them again.

-- The default game is played with 9 piles (1 for each of the Fellowship (Freep) or Nazgul (Creep)) and 4 suits (1 for each race + ring/eye)
-- The Creep deck is not yet available in version 1.0 - I should have it available soon but I will likely get sidetracked and forget about this for a couple of months :(

-- The Ring plugin is designed to allow use of custom decks - each deck must have 45 cards (9 cards per suit, 5 suits) (all suits/cards must exist even if the user never selects to play with all suits, otherwise B.A.D. things may happen)
-- for creating custom decks, see the RingDecks/Standard folder.


dataVersion=nil;
Pile={};
Stack={};
Hand={};
RingState=true;
StatsState=true;
RulesState=true;
RingHUDState=true;
Stats={};

tableX=Turbine.UI.Display:GetWidth()/2-30;
tableY=Turbine.UI.Display:GetHeight()/2-50;
deckName="Standard";
Decks={}; -- collection of decks
cardMoving=false;

Celebrating=false;
VictoryDeck={};
VictoryAngle=0;
GameStart=0;

string.split=function(str,separator)
	local tmpArray={};
	local tmpElem;
	str=tostring(str);
	if string.find("^$()%.[]*+-?",separator,1,true)~=nil then separator="%"..separator end
	for tmpElem in string.gmatch(str,"[^"..separator.."]*") do
		table.insert(tmpArray,tmpElem);
	end
	local tmpIndex=1;
	while tmpIndex<=#tmpArray do
		if tmpIndex==#tmpArray and tmpArray[tmpIndex]=="" then
			table.remove(tmpArray,tmpIndex);
		else
			if tmpArray[tmpIndex]=="" and tmpArray[tmpIndex+1]~="" then
				table.remove(tmpArray,tmpIndex);
			else
				tmpIndex=tmpIndex+1;
			end
		end
	end
	return tmpArray;
end
string.ltrim=function(str)
	return (string.gsub(str, "^%s*(.-)", "%1"))
end
string.rtrim=function(str)
	return (string.gsub(str, "^(.-)%s*$", "%1"))
end
string.trim=function(str)
	return (string.gsub(str, "^%s*(.-)%s*$", "%1"))
end

Decks=PatchDataLoad(Turbine.DataScope.Account, "Ring_Decks");
if Decks==nil then
	Decks={};
	import "GaranStuff.Cards.RingDecks.Standard.Deck"; -- define the standard deck
	import "GaranStuff.Cards.RingDecks.Plain.Deck"; -- define the plain deck
end
Stats=PatchDataLoad(Turbine.DataScope.Account, "Ring_Stats");
if Stats==nil then
	Stats={};
	local tmpPiles
	for tmpPiles=1,9 do
		Stats[tmpPiles]={{},{},{},{},{}};
	end
end

SelectedCards={}
SelectedCards.Bottom=Card();
SelectedCards.Bottom:SetVisible(false);
SelectedCards.Top=Card();
SelectedCards.Top:SetVisible(false);

SelectedCards.Bottom.CheckPosition=function(sender,args)
	-- this routine just lets us highlight possible valid drops
	local left,top=SelectedCards.Bottom:GetPosition();
	-- check whether the card that is being moved is near any of the stacks/piles
	for tmpIndex=1,#Pile do
--		if SelectedCards.Bottom.Suit==Pile[tmpIndex].Top.Suit and SelectedCards.Bottom.Number==Pile[tmpIndex].Top.Number-1 and math.abs(Pile[tmpIndex].Top:GetLeft()-left)<40 and math.abs(Pile[tmpIndex].Top:GetTop()-top)<40 then
		if (Pile[tmpIndex].Top.Suit==0 or SelectedCards.Bottom.Suit==Pile[tmpIndex].Top.Suit) and SelectedCards.Bottom.Number==Pile[tmpIndex].Top.Number-1 and math.abs(Pile[tmpIndex].Top:GetLeft()-left)<40 and math.abs(Pile[tmpIndex].Top:GetTop()-top)<40 then
			Pile[tmpIndex].Top.Border:SetBackground("GaranStuff/Cards/Resources/Highlight.tga");
			Pile[tmpIndex].Top.Border:SetVisible(true);
		else
			Pile[tmpIndex].Top.Border:SetVisible(false);
		end
	end
	for tmpIndex=1,#Stack do
		Stack[tmpIndex].Border:SetVisible(false);
		if SelectedCards.Top.Suit==Stack[tmpIndex].Suit and SelectedCards.Top.Number==Stack[tmpIndex].Number+1 and math.abs(Stack[tmpIndex]:GetLeft()-left)<40 and math.abs(Stack[tmpIndex]:GetTop()-top)<40 then
			Stack[tmpIndex].Border:SetBackground("GaranStuff/Cards/Resources/Highlight.tga");
			Stack[tmpIndex].Border:SetVisible(true);
		else
			Stack[tmpIndex].Border:SetVisible(false);
		end
	end
end
SelectedCards.Top.CheckPosition=function(sender,args)

	-- this routine just lets us highlight possible valid drops
	local left,top=SelectedCards.Top:GetPosition();
	-- check whether the card that is being moved is near any of the stacks/piles
	for tmpIndex=1,#Pile do
--		if SelectedCards.Top.Suit==Pile[tmpIndex].Top.Suit and SelectedCards.Top.Number==Pile[tmpIndex].Top.Number-1 and math.abs(Pile[tmpIndex].Top:GetLeft()-left)<40 and math.abs(Pile[tmpIndex].Top:GetTop()-top)<40 then
		if (Pile[tmpIndex].Top.Suit==0 or SelectedCards.Top.Suit==Pile[tmpIndex].Top.Suit) and SelectedCards.Top.Number==Pile[tmpIndex].Top.Number-1 and math.abs(Pile[tmpIndex].Top:GetLeft()-left)<40 and math.abs(Pile[tmpIndex].Top:GetTop()-top)<40 then
			Pile[tmpIndex].Top.Border:SetBackground("GaranStuff/Cards/Resources/Highlight.tga");
			Pile[tmpIndex].Top.Border:SetVisible(true);
		else
			Pile[tmpIndex].Top.Border:SetVisible(false);
		end
	end
	for tmpIndex=1,#Stack do
		Stack[tmpIndex].Border:SetVisible(false);
		if SelectedCards.Top.Suit==Stack[tmpIndex].Suit and SelectedCards.Top.Number==Stack[tmpIndex].Number+1 and math.abs(Stack[tmpIndex]:GetLeft()-left)<40 and math.abs(Stack[tmpIndex]:GetTop()-top)<40 then
			Stack[tmpIndex].Border:SetBackground("GaranStuff/Cards/Resources/Highlight.tga");
			Stack[tmpIndex].Border:SetVisible(true);
		else
			Stack[tmpIndex].Border:SetVisible(false);
		end
	end
end

SelectedCards.Bottom.CheckDrop=function(sender,args)
	-- this routine actually performs the drop if it's valid
	local dropped=false;
	local left,top=SelectedCards.Bottom:GetPosition();
	-- check whether the card that is being moved is near any of the stacks/piles
	for tmpIndex=1,#Pile do
		Pile[tmpIndex].Top.Border:SetVisible(false);
		if (Pile[tmpIndex].Top.Suit==0 or SelectedCards.Bottom.Suit==Pile[tmpIndex].Top.Suit) and SelectedCards.Bottom.Number==Pile[tmpIndex].Top.Number-1 and math.abs(Pile[tmpIndex].Top:GetLeft()-left)<40 and math.abs(Pile[tmpIndex].Top:GetTop()-top)<40 then
			-- drop SelectedCards.Top card on this pile
			local tmpNumber;
			for tmpNumber=SelectedCards.Bottom.Number,SelectedCards.Top.Number,-1 do
				Pile[tmpIndex].Cards[#Pile[tmpIndex].Cards+1]={SelectedCards.Top.Suit,tmpNumber};
			end
			-- set pile top card to selected top card
			Pile[tmpIndex].Top.Suit=SelectedCards.Top.Suit;
			Pile[tmpIndex].Top.Number=SelectedCards.Top.Number;
			Pile[tmpIndex].Top.FaceImage=SelectedCards.Top.FaceImage;
			Pile[tmpIndex].Top.SuitIconImage=SelectedCards.Top.SuitIconImage;
			Pile[tmpIndex].Top:SetFacing(GaranStuff.Cards.FaceUp);

			if #Pile[tmpIndex].Cards>1 then
				Pile[tmpIndex].Bottom.Suit=Pile[tmpIndex].Cards[1][1];
				Pile[tmpIndex].Bottom.Number=Pile[tmpIndex].Cards[1][2];
				Pile[tmpIndex].Bottom.FaceImage=Decks[deckName].Cards[Pile[tmpIndex].Cards[1][1]][Pile[tmpIndex].Cards[1][2]];
				Pile[tmpIndex].Bottom.SuitIconImage=Decks[deckName][Decks[deckName].Suits[Pile[tmpIndex].Cards[1][1]]][1];
				Pile[tmpIndex].Bottom:SetFacing(GaranStuff.Cards.FaceUp);
				Pile[tmpIndex].Bottom:SetVisible(true);
				Pile[tmpIndex].Top:SetZOrder(Pile[tmpIndex].Bottom:GetZOrder()+1);
			end
			dropped=true;
		end
	end
	for tmpIndex=1,#Stack do
		Stack[tmpIndex].Border:SetVisible(false);
		-- remember that cards go onto stacks lowest to highest, so we check the TOP selected card's number
		if SelectedCards.Top.Suit==Stack[tmpIndex].Suit and SelectedCards.Top.Number==Stack[tmpIndex].Number+1 and math.abs(Stack[tmpIndex]:GetLeft()-left)<40 and math.abs(Stack[tmpIndex]:GetTop()-top)<40 then
			-- drop SelectedCards.Top card on this stack

			local tmpNumber;
			for tmpNumber=SelectedCards.Top.Number,SelectedCards.Bottom.Number do
				Stack[tmpIndex].Cards[#Stack[tmpIndex].Cards+1]={SelectedCards.Top.Suit,tmpNumber};
			end

			-- set stack top card to selected BOTTOM card
			Stack[tmpIndex].Suit=SelectedCards.Bottom.Suit;
			Stack[tmpIndex].Number=SelectedCards.Bottom.Number;
			Stack[tmpIndex].FaceImage=SelectedCards.Bottom.FaceImage;
			Stack[tmpIndex].SuitIconImage=SelectedCards.Bottom.SuitIconImage;
			Stack[tmpIndex]:SetFacing(GaranStuff.Cards.FaceUp);
			dropped=true;
		end
	end
	return dropped;
end
SelectedCards.Top.CheckDrop=function(sender,args)
	-- this routine actually performs the drop if it's valid
	local dropped=false;
	local left,top=SelectedCards.Top:GetPosition();
	-- check whether the card that is being moved is near any of the stacks/piles
	for tmpIndex=1,#Pile do
		Pile[tmpIndex].Top.Border:SetVisible(false);
		if (Pile[tmpIndex].Top.Suit==0 or SelectedCards.Top.Suit==Pile[tmpIndex].Top.Suit) and SelectedCards.Top.Number==Pile[tmpIndex].Top.Number-1 and math.abs(Pile[tmpIndex].Top:GetLeft()-left)<40 and math.abs(Pile[tmpIndex].Top:GetTop()-top)<40 then
			-- drop SelectedCards.Top card on this pile
			Pile[tmpIndex].Cards[#Pile[tmpIndex].Cards+1]={SelectedCards.Top.Suit,SelectedCards.Top.Number};
			Pile[tmpIndex].Top.Suit=SelectedCards.Top.Suit;
			Pile[tmpIndex].Top.Number=SelectedCards.Top.Number;
			Pile[tmpIndex].Top.FaceImage=SelectedCards.Top.FaceImage;
			Pile[tmpIndex].Top.SuitIconImage=SelectedCards.Top.SuitIconImage;
			Pile[tmpIndex].Top:SetFacing(GaranStuff.Cards.FaceUp);
			if #Pile[tmpIndex].Cards>1 then
				Pile[tmpIndex].Bottom.Suit=Pile[tmpIndex].Cards[1][1];
				Pile[tmpIndex].Bottom.Number=Pile[tmpIndex].Cards[1][2];
				Pile[tmpIndex].Bottom.FaceImage=Decks[deckName].Cards[Pile[tmpIndex].Cards[1][1]][Pile[tmpIndex].Cards[1][2]];
				Pile[tmpIndex].Bottom.SuitIconImage=Decks[deckName][Decks[deckName].Suits[Pile[tmpIndex].Cards[1][1]]][1];
				Pile[tmpIndex].Bottom:SetFacing(GaranStuff.Cards.FaceUp);
				Pile[tmpIndex].Bottom:SetVisible(true);
				Pile[tmpIndex].Top:SetZOrder(Pile[tmpIndex].Bottom:GetZOrder()+1);
			end
			dropped=true;
		end
	end
	for tmpIndex=1,#Stack do
		Stack[tmpIndex].Border:SetVisible(false);
		if SelectedCards.Top.Suit==Stack[tmpIndex].Suit and SelectedCards.Top.Number==Stack[tmpIndex].Number+1 and math.abs(Stack[tmpIndex]:GetLeft()-left)<40 and math.abs(Stack[tmpIndex]:GetTop()-top)<40 then
			-- drop SelectedCards.Top card on this stack
			Stack[tmpIndex].Cards[#Stack[tmpIndex].Cards+1]={SelectedCards.Top.Suit,SelectedCards.Top.Number};
			Stack[tmpIndex].Suit=SelectedCards.Top.Suit;
			Stack[tmpIndex].Number=SelectedCards.Top.Number;
			Stack[tmpIndex].FaceImage=SelectedCards.Top.FaceImage;
			Stack[tmpIndex].SuitIconImage=SelectedCards.Top.SuitIconImage;
			Stack[tmpIndex]:SetFacing(GaranStuff.Cards.FaceUp);
			dropped=true;
		end
	end
	return dropped;
end

Chute={};
-- the Chute shows the playable cards from Hand
Chute.FaceUpIndex=0;
Chute.Left=0;
Chute.Top=0;
Chute.AddCard=function(tmpSuit,tmpOrdinal)
	local tmpIndex=#Chute+1;
	Chute[tmpIndex]=Card();
	Chute[tmpIndex].Index=tmpIndex;
	Chute[tmpIndex]:SetPosition(Chute.Left,Chute.Top);
	Chute[tmpIndex].BackImage=Decks[deckName][Decks[deckName].Suits[tmpSuit]][2];
	Chute[tmpIndex].FaceImage=(Decks[deckName].Cards[tmpSuit][tmpOrdinal]);
	Chute[tmpIndex].SuitIconImage=Decks[deckName][Decks[deckName].Suits[tmpSuit]][1];
	Chute[tmpIndex].Suit=tmpSuit;
	Chute[tmpIndex].Number=tmpOrdinal;
	Chute[tmpIndex]:SetFacing(GaranStuff.Cards.FaceDown);
	Chute[tmpIndex]:SetRotation({x=0,y=0,z=0});
	Chute[tmpIndex]:SetVisible(true);
	Chute[tmpIndex]:SetZOrder(ringMain:GetZOrder()+tmpIndex);

	Chute[tmpIndex].MouseDown=function(sender,args)
		if args.Button==1 and sender.Suit>0 and sender:GetFacing()==GaranStuff.Cards.FaceUp and sender.Index==Chute.FaceUpIndex then
			SelectedCards.Top:SetPosition(sender:GetPosition());
			SelectedCards.Top.FaceImage=(Decks[deckName].Cards[sender.Suit][sender.Number]);
			SelectedCards.Top.SuitIconImage=Decks[deckName][Decks[deckName].Suits[sender.Suit]][1];
			SelectedCards.Top.Suit=sender.Suit;
			SelectedCards.Top.Number=sender.Number;
			SelectedCards.Top:SetFacing(GaranStuff.Cards.FaceUp);
			SelectedCards.Top:SetZOrder(sender:GetZOrder()+1);
			SelectedCards.Top:SetRotation(sender:GetRotation());
			SelectedCards.Top:SetVisible(true);
			SelectedCards.Top:SetZOrder(sender:GetZOrder()+1);
			SelectedCards.Top.X=args.X;
			SelectedCards.Top.Y=args.Y;
			cardMoving=true;
			sender:SetOpacity(0); -- hide the Chute element without actually making it non-visible so that it still gets mouse messages
		end
	end

	Chute[tmpIndex].MouseUp=function(sender,args)
		if args.Button==1 then
			SelectedCards.Top:SetVisible(false);
			cardMoving=false;
			if SelectedCards.Top:CheckDrop(args) then
				-- remove this element
				sender.MouseDown=nil;
				sender.MouseUp=nil;
				sender.MouseMove=nil;
				sender.MouseClick=nil;
				local tmpIndex;
				-- before removing the element, we have to adjust all of the indexes above it
				for tmpIndex=sender.Index+1, #Chute do
					Chute[tmpIndex].Index=tmpIndex-1;
				end
				sender:SetVisible(false);
				table.remove(Chute,sender.Index);
				CheckWin();
				if Chute.FaceUpIndex==1 then
					ringMain.CheatButton:SetVisible(false);
				else
					if #Chute>0 then
						ringMain.CheatButton:SetVisible(true);
					end
				end
			else
				sender:SetOpacity(1); -- make the Chute element visible again
			end
		end
	end

	Chute[tmpIndex].MouseMove=function(sender,args)
		if cardMoving then
			local left,top=SelectedCards.Top:GetPosition();
			if args.X~=SelectedCards.Top.X then
				left=SelectedCards.Top:GetLeft()-(SelectedCards.Top.X-args.X)
				SelectedCards.Top.X=args.X;
			end
			if args.Y~=SelectedCards.Top.Y then
				top=SelectedCards.Top:GetTop()-(SelectedCards.Top.Y-args.Y)
				SelectedCards.Top.Y=args.Y;
			end
			SelectedCards.Top:SetPosition(left,top);
			SelectedCards.Top:CheckPosition(args);
		end
	end

	Chute[tmpIndex].MouseClick=function(sender,args)
		if args.Button==2 then
			if sender:GetFacing()==GaranStuff.Cards.FaceDown then

				tmpIndex=sender.Index
				while tmpIndex>0 and tmpIndex>=sender.Index-2 do
					if tmpIndex==#Chute then
						Chute[tmpIndex]:SetZOrder(ringMain:GetZOrder()+1);
					else
						Chute[tmpIndex]:SetZOrder(Chute[tmpIndex+1]:GetZOrder()+1);
					end
					Chute.FaceUpIndex=tmpIndex;
					Chute[tmpIndex]:SetFacing(GaranStuff.Cards.FaceUp);
					--Chute[tmpIndex]:SetPosition(Chute.Left+Chute[1]:GetWidth()+2+tmpIndex*2,Chute.Top);
					Chute[tmpIndex]:SetPosition(Chute.Left+Chute[1]:GetWidth()+2,Chute.Top);
					tmpIndex=tmpIndex-1;
				end
				if Chute.FaceUpIndex==1 then
					ringMain.CheatButton:SetVisible(false);
				else
					ringMain.CheatButton:SetVisible(true);
				end
			else
				if sender.Index==1 then
					-- flip all cards facedown, reposition them to left of Chute and change ZOrder
					local tmpIndex
					for tmpIndex=1,#Chute do
						Chute[tmpIndex]:SetFacing(GaranStuff.Cards.FaceDown);
						Chute[tmpIndex]:SetPosition(Chute.Left,Chute.Top);
						Chute[tmpIndex]:SetZOrder(ringMain:GetZOrder()+tmpIndex);
					end
					Chute.FaceUpIndex=0;
					ringMain.CheatButton:SetVisible(true);
				end
			end
		end
	end
end

function CheckWin()
	local win=true;
	local tmpIndex;
	local numSuits=#Stack
	for tmpIndex=1,numSuits do
		if #Stack[tmpIndex].Cards<9 then
			win=false;
		end
	end
	if win then
		local TimeElapsed=Turbine.Engine.GetLocalTime()-GameStart;
		local numPiles=#Pile
		if Stats[numPiles][numSuits].GamesWon==nil then
			Stats[numPiles][numSuits].GamesWon=1;
		else
			Stats[numPiles][numSuits].GamesWon=Stats[numPiles][numSuits].GamesWon+1;
		end
		if Stats[numPiles][numSuits].BestTime==nil then
			Stats[numPiles][numSuits].BestTime=TimeElapsed;
		else
			if Stats[numPiles][numSuits].BestTime>TimeElapsed then
				Stats[numPiles][numSuits].BestTime=TimeElapsed;
			end
		end
		if Stats[numPiles][numSuits].WorstTime==nil then
			Stats[numPiles][numSuits].WorstTime=TimeElapsed;
		else
			if Stats[numPiles][numSuits].WorstTime<TimeElapsed then
				Stats[numPiles][numSuits].WorstTime=TimeElapsed;
			end
		end

		ringMain.CheatButton:SetVisible(false);
		-- show some celebratory animation
		VictoryDeck={};
		Celebrating=true
		ringMain:SetWantsUpdates( true );
	end
end

RingMainWindow = class( Turbine.UI.Lotro.Window );

function RingMainWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );
	self.Backdrop=Turbine.UI.Window();
	self.Backdrop:SetSize(Turbine.UI.Display:GetWidth(),Turbine.UI.Display:GetWidth())
	self.Backdrop:SetBackColor(Turbine.UI.Color(0,0,0));
	self.Backdrop:SetOpacity(.7);
	self.Backdrop:SetZOrder(-1);

	self:SetWantsUpdates( false );
	self:SetWantsKeyEvents(true);

	self:SetText(Resource[language][3]);
	self.popUp=nil;

	self:SetSize(300,225);
	self:SetPosition((Turbine.UI.Display:GetWidth()-self:GetHeight())/2,(Turbine.UI.Display:GetHeight()-self:GetHeight())/2)

	self.DeckCaption=Turbine.UI.Label();
	self.DeckCaption:SetParent(self);
	self.DeckCaption:SetSize(130,20);
	self.DeckCaption:SetPosition(10,45);
	self.DeckCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
	self.DeckCaption:SetForeColor(fontColor);
	self.DeckCaption:SetText(Resource[language][12]..":");

	self.DeckSelect=DropDownList();
	self.DeckSelect:SetParent(self);
	self.DeckSelect:SetSize(145,20);
	self.DeckSelect:SetPosition(self.DeckCaption:GetLeft()+self.DeckCaption:GetWidth(),self.DeckCaption:GetTop());
	self.DeckSelect:SetBorderColor(trimColor);
	self.DeckSelect:SetBackColor(backColor);
	self.DeckSelect.CurrentValue:SetBackColor(backColor);
	self.DeckSelect:SetTextColor(listTextColor);
	self.DeckSelect:SetDropRows(5);
	self.DeckSelect.SelectedIndexChanged=function()
		deckName=self.DeckSelect:GetValue();
	end

	local tmpDeck,tmpID
	for tmpDeck,tmpID in pairs(Decks) do
		self.DeckSelect:AddItem(tmpDeck,tmpDeck);
	end
	self.DeckSelect:SetSelectedIndex(1);
	deckName=self.DeckSelect:GetValue();


	self.DeckSelect:SetZOrder(1);

	self.PilesCaption=Turbine.UI.Label();
	self.PilesCaption:SetParent(self);
	self.PilesCaption:SetSize(130,20);
	self.PilesCaption:SetPosition(10,self.DeckCaption:GetTop()+25);
	self.PilesCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
	self.PilesCaption:SetForeColor(fontColor);
	self.PilesCaption:SetText(Resource[language][7].." (3-9):");
	self.PilesText=Turbine.UI.Lotro.TextBox();
	self.PilesText:SetParent(self);
	self.PilesText:SetSize(50,20);
	self.PilesText:SetFont(fontFace);
	self.PilesText:SetPosition(self.PilesCaption:GetLeft()+self.PilesCaption:GetWidth(),self.PilesCaption:GetTop());
	self.PilesText:SetText("9");

	self.SuitsCaption=Turbine.UI.Label();
	self.SuitsCaption:SetParent(self);
	self.SuitsCaption:SetSize(130,20);
	self.SuitsCaption:SetPosition(10,self.PilesCaption:GetTop()+25);
	self.SuitsCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft );
	self.SuitsCaption:SetForeColor(fontColor);
	self.SuitsCaption:SetText(Resource[language][8].." (2-5):");
	self.SuitsText=Turbine.UI.Lotro.TextBox();
	self.SuitsText:SetParent(self);
	self.SuitsText:SetSize(50,20);
	self.SuitsText:SetFont(fontFace);
	self.SuitsText:SetPosition(self.SuitsCaption:GetLeft()+self.SuitsCaption:GetWidth(),self.SuitsCaption:GetTop());
	self.SuitsText:SetText("3");

	self.CheatButton=Turbine.UI.Lotro.Button();
	self.CheatButton:SetParent(self);
	self.CheatButton:SetSize(100,20);
	self.CheatButton:SetPosition((self:GetWidth()-self.CheatButton:GetWidth())/2,self:GetHeight()-self.CheatButton:GetHeight()-65);
	self.CheatButton:SetForeColor(fontColor);
	self.CheatButton:SetText(Resource[language][26]);
	self.CheatButton:SetVisible(false);
	self.CheatButton.MouseClick=function()
		-- flip a single card instead of 3
		if #Chute>0 then
			if Stats[#Pile][#Stack].TimesCheat==nil then
				Stats[#Pile][#Stack].TimesCheat=1
			else
				Stats[#Piles][#Stack].TimesCheat=Stats[#Pile][#Stack].TimesCheat+1;
			end
			if Chute.FaceUpIndex==0 then
				tmpIndex=#Chute;
				Chute[tmpIndex]:SetZOrder(ringMain:GetZOrder()+1);
				Chute.FaceUpIndex=tmpIndex;
				Chute[tmpIndex]:SetFacing(GaranStuff.Cards.FaceUp);
				--Chute[tmpIndex]:SetPosition(Chute.Left+Chute[1]:GetWidth()+2+tmpIndex*2,Chute.Top);
				Chute[tmpIndex]:SetPosition(Chute.Left+Chute[1]:GetWidth()+2,Chute.Top);
			else
				if Chute.FaceUpIndex>1 then
					tmpIndex=Chute.FaceUpIndex-1;
					Chute[tmpIndex]:SetZOrder(Chute[tmpIndex+1]:GetZOrder()+1);
					Chute.FaceUpIndex=tmpIndex;
					Chute[tmpIndex]:SetFacing(GaranStuff.Cards.FaceUp);
					--Chute[tmpIndex]:SetPosition(Chute.Left+Chute[1]:GetWidth()+2+tmpIndex*2,Chute.Top);
					Chute[tmpIndex]:SetPosition(Chute.Left+Chute[1]:GetWidth()+2,Chute.Top);
				end
			end
		end
	end

	self.MenuButton=Turbine.UI.Lotro.Button();
	self.MenuButton:SetParent(self);
	self.MenuButton:SetSize(100,20);
	self.MenuButton:SetPosition(30,self:GetHeight()-self.MenuButton:GetHeight()-40);
	self.MenuButton:SetForeColor(fontColor);
	self.MenuButton:SetText(Resource[language][11]);
	self.MenuButton.MouseClick=function()
		self:SetVisible(false);
		cardsWindow:SetVisible(true);
	end

	self.StatsButton=Turbine.UI.Lotro.Button();
	self.StatsButton:SetParent(self);
	self.StatsButton:SetSize(100,20);
	self.StatsButton:SetPosition(self:GetWidth()-self.StatsButton:GetWidth()-30,self:GetHeight()-self.StatsButton:GetHeight()-40);
	self.StatsButton:SetForeColor(fontColor);
	self.StatsButton:SetText(Resource[language][27]);
	self.StatsButton.MouseClick=function()
		ringMain.StatsWindow:SetVisible(true);
		ringMain.StatsWindow:Refresh();
		-- display the player's stats
		-- BestTime (seconds)
		-- WorstTime(seconds)
		-- GamesPlayed
		-- GamesWon, % wins
		-- TimesCheat, % cheats
	end

	self.DealButton=Turbine.UI.Lotro.Button();
	self.DealButton:SetParent(self);
	self.DealButton:SetSize(100,20);
	self.DealButton:SetPosition(30,self:GetHeight()-self.DealButton:GetHeight()-15);
	self.DealButton:SetForeColor(fontColor);
	self.DealButton:SetText(Resource[language][9]);
	self.DealButton.MouseClick=function()
		local piles=tonumber(self.PilesText:GetText());
		local suits=tonumber(self.SuitsText:GetText());
		if piles==nil or piles<3 then piles=3 end
		if piles>9 then piles=9 end
		if suits==nil or suits<2 then suits=2 end
		if suits>5 then suits=5 end
		self.PilesText:SetText(piles);
		self.SuitsText:SetText(suits);
		ringMain.DealCards(piles,suits);
		self.CheatButton:SetVisible(true);
		-- start the elapsed game timer
		GameStart=Turbine.Engine.GetLocalTime();
		if Stats[piles][suits].GamesPlayed==nil then
			Stats[piles][suits].GamesPlayed=1
		else
			Stats[piles][suits].GamesPlayed=Stats[piles][suits].GamesPlayed+1;
		end
	end

	self.RulesButton=Turbine.UI.Lotro.Button();
	self.RulesButton:SetParent(self);
	self.RulesButton:SetSize(100,20);
	self.RulesButton:SetPosition(self:GetWidth()-self.RulesButton:GetWidth()-30,self:GetHeight()-self.RulesButton:GetHeight()-15);
	self.RulesButton:SetForeColor(fontColor);
	self.RulesButton:SetText(Resource[language][28]);
	self.RulesButton.MouseClick=function()
		-- display the game rules in the current language...
		self.RulesWindow:SetVisible(true);
	end

	self.DealCards=function(numPiles,numSuits)

		local tmpIndex;
		if numPiles==nil then numPiles=9 end -- the smaller the number of Piles, the harder the game gets
		if numSuits==nil then numSuits=5 end -- the more Suits in play, the harder the game gets (and lasts longer)
		SelectedCards.Bottom.BackImage=Decks[deckName].Background;
		SelectedCards.Top.BackImage=Decks[deckName].Background;
	
		-- clear the prior game
		while #Pile>0 do
			Pile[#Pile].Top:SetVisible(false);
			Pile[#Pile].Top.MouseEnter=nil;
			Pile[#Pile].Top.MouseLeave=nil;
			Pile[#Pile].Top.MouseDown=nil;
			Pile[#Pile].Top.MouseUp=nil;
			Pile[#Pile].Top.MouseMove=nil;
			Pile[#Pile].Top=nil;
			Pile[#Pile].Bottom:SetVisible(false);
			Pile[#Pile].Bottom.MouseEnter=nil;
			Pile[#Pile].Bottom.MouseLeave=nil;
			Pile[#Pile].Bottom.MouseDown=nil;
			Pile[#Pile].Bottom.MouseUp=nil;
			Pile[#Pile].Bottom.MouseMove=nil;
			Pile[#Pile].Bottom=nil;
			Pile[#Pile]=nil;
			table.remove(Pile,#Pile)
		end
		
		while #Chute>0 do
			Chute[#Chute]:SetVisible(false);
			Chute[#Chute].MouseEnter=nil;
			Chute[#Chute].MouseLeave=nil;
			Chute[#Chute].MouseDown=nil;
			Chute[#Chute].MouseUp=nil;
			Chute[#Chute].MouseMove=nil;
			Chute[#Chute]=nil;
			table.remove(Chute,#Chute);
		end

		while #Stack>0 do
			Stack[#Stack]:SetVisible(false);
			Stack[#Stack]=nil;
			table.remove(Stack,#Stack)
		end

		-- force a garbage collect to clean up the graphics schmegma (SetVisible(false) wasn't sufficient)
		collectgarbage("collect");

		for tmpIndex=1,numPiles do
			Pile[tmpIndex]={};
			Pile[tmpIndex].Top=Card();
			Pile[tmpIndex].Bottom=Card();
			if numPiles<8 then
				Pile[tmpIndex].Top:SetPosition(tableX+math.cos(math.rad((tmpIndex-1)/numPiles*360))*240,tableY+math.sin(math.rad((tmpIndex-1)/numPiles*360))*240)
			else
				Pile[tmpIndex].Top:SetPosition(tableX+math.cos(math.rad((tmpIndex-1)/numPiles*360))*numPiles*27,tableY+math.sin(math.rad((tmpIndex-1)/numPiles*360))*numPiles*27)
			end
			Pile[tmpIndex].Cards={};
			Pile[tmpIndex].Top.BackImage=Decks[deckName].Background;
			Pile[tmpIndex].Top:SetRotation({x=0,y=0,z=-(tmpIndex-1)/numPiles*360});
			Pile[tmpIndex].Bottom.BackImage=Decks[deckName].Background;
			Pile[tmpIndex].Bottom:SetRotation({x=0,y=0,z=-(tmpIndex-1)/numPiles*360});
			Pile[tmpIndex].Bottom:SetPosition(Pile[tmpIndex].Top:GetLeft()-20,Pile[tmpIndex].Top:GetTop()-20);
			Pile[tmpIndex].Bottom.Top=Pile[tmpIndex].Top; -- bottom card needs a pointer to top card for event handlers
			Pile[tmpIndex].Top:SetVisible(true);
			Pile[tmpIndex].Top.Index=tmpIndex;

			Pile[tmpIndex].Top.MouseEnter=function(sender,args)
				sender.Border:SetBackground("GaranStuff/Cards/Resources/Select.tga");
				sender.Border:SetVisible(true);
			end

			Pile[tmpIndex].Top.MouseLeave=function(sender,args)
				sender.Border:SetVisible(false);
			end

			Pile[tmpIndex].Top.MouseDown=function(sender,args)
				sender.Border:SetVisible(false);
				if args.Button==1 and Pile[tmpIndex].Top.Number>0 and Pile[tmpIndex].Top.Number<10 then
					SelectedCards.Top:SetPosition(sender:GetLeft(),sender:GetTop());
					SelectedCards.Top.FaceImage=Decks[deckName].Cards[sender.Suit][sender.Number];
					SelectedCards.Top.SuitIconImage=Decks[deckName][Decks[deckName].Suits[sender.Suit]][1];
					SelectedCards.Top.Suit=sender.Suit;
					SelectedCards.Top.Number=sender.Number;
					SelectedCards.Top:SetFacing(GaranStuff.Cards.FaceUp);
					SelectedCards.Top:SetZOrder(sender:GetZOrder()+1);
					SelectedCards.Top:SetRotation(sender:GetRotation());
					SelectedCards.Top:SetVisible(true);
					SelectedCards.Top.X=args.X;
					SelectedCards.Top.Y=args.Y;
					cardMoving=true;
				end
			end

			Pile[tmpIndex].Top.MouseUp=function(sender,args)
				if args.Button==1 then
					if SelectedCards.Top:CheckDrop(args) then
						-- card was dropped, remove it from this pile
						table.remove(Pile[tmpIndex].Cards)
						if #Pile[tmpIndex].Cards>0 then
							if #Pile[tmpIndex].Cards<2 then
								Pile[tmpIndex].Bottom:SetVisible(false);
							end
							Pile[tmpIndex].Top.Suit=Pile[tmpIndex].Cards[#Pile[tmpIndex].Cards][1];
							Pile[tmpIndex].Top.Number=Pile[tmpIndex].Cards[#Pile[tmpIndex].Cards][2];
							Pile[tmpIndex].Top.SuitIconImage=Decks[deckName][Decks[deckName].Suits[Pile[tmpIndex].Top.Suit]][1];
							Pile[tmpIndex].Top.FaceImage=Decks[deckName].Cards[Pile[tmpIndex].Top.Suit][Pile[tmpIndex].Top.Number];
							Pile[tmpIndex].Top:SetFacing(GaranStuff.Cards.FaceUp);
						else
							Pile[tmpIndex].Top.Number=10;
							Pile[tmpIndex].Top.Suit=0;
							Pile[tmpIndex].Top.FaceImage=Pile[tmpIndex].Top.BackImage;
							Pile[tmpIndex].Top:SetFacing(GaranStuff.Cards.FaceDown); -- hides the suit and number
							Pile[tmpIndex].Bottom:SetVisible(false);
							CheckWin();
						end
					end
					SelectedCards.Bottom:SetVisible(false);
					SelectedCards.Top:SetVisible(false);
					cardMoving=false;
				end
			end

			Pile[tmpIndex].Top.MouseMove=function(sender,args)
				if cardMoving then
					local left,top=SelectedCards.Top:GetPosition();
					if args.X~=SelectedCards.Top.X then
						left=SelectedCards.Top:GetLeft()-(SelectedCards.Top.X-args.X)
						SelectedCards.Top.X=args.X;
					end
					if args.Y~=SelectedCards.Top.Y then
						top=SelectedCards.Top:GetTop()-(SelectedCards.Top.Y-args.Y)
						SelectedCards.Top.Y=args.Y;
					end
					SelectedCards.Top:SetPosition(left,top);
					SelectedCards.Top:CheckPosition(args);
				end
			end

			Pile[tmpIndex].Bottom.MouseEnter=function(sender,args)
				sender.Border:SetBackground("GaranStuff/Cards/Resources/Select.tga");
				sender.Border:SetVisible(true);
			end

			Pile[tmpIndex].Bottom.MouseLeave=function(sender,args)
				sender.Border:SetVisible(false);
			end

			Pile[tmpIndex].Bottom.MouseDown=function(sender,args)
				sender.Border:SetVisible(false);
				if args.Button==1 and Pile[tmpIndex].Bottom.Number>0 and Pile[tmpIndex].Bottom.Number<10 then
					SelectedCards.Top:SetPosition(sender:GetLeft(),sender:GetTop());
					SelectedCards.Top.FaceImage=(Decks[deckName].Cards[sender.Top.Suit][sender.Top.Number]);
					SelectedCards.Top.SuitIconImage=Decks[deckName][Decks[deckName].Suits[sender.Top.Suit]][1];
					SelectedCards.Top.Suit=sender.Top.Suit;
					SelectedCards.Top.Number=sender.Top.Number;
					SelectedCards.Top:SetFacing(GaranStuff.Cards.FaceUp);
					SelectedCards.Top:SetRotation(sender:GetRotation());
					SelectedCards.Top:SetVisible(true);
					SelectedCards.Top.X=args.X;
					SelectedCards.Top.Y=args.Y;

					SelectedCards.Bottom.FaceImage=(Decks[deckName].Cards[sender.Suit][sender.Number]);
					SelectedCards.Bottom.SuitIconImage=Decks[deckName][Decks[deckName].Suits[sender.Suit]][1];
					SelectedCards.Bottom.Suit=sender.Suit;
					SelectedCards.Bottom.Number=sender.Number;
					SelectedCards.Bottom:SetFacing(GaranStuff.Cards.FaceUp);
					SelectedCards.Bottom:SetZOrder(sender:GetZOrder()+1);
					SelectedCards.Bottom:SetRotation(sender:GetRotation());
					SelectedCards.Bottom:SetVisible(true);
					SelectedCards.Bottom:SetPosition(SelectedCards.Top:GetLeft()-20,SelectedCards.Top:GetTop()-20);
					SelectedCards.Top:SetZOrder(SelectedCards.Bottom:GetZOrder()+1);
					cardMoving=true;
				end
			end

			Pile[tmpIndex].Bottom.MouseUp=function(sender,args)
				if args.Button==1 then
					if SelectedCards.Bottom:CheckDrop(args) then
						-- cards were dropped, remove them from this pile
						Pile[tmpIndex].Cards={};
						Pile[tmpIndex].Top.Number=10;
						Pile[tmpIndex].Top.Suit=0;
						Pile[tmpIndex].Top.FaceImage=Pile[tmpIndex].Top.BackImage;
						Pile[tmpIndex].Top:SetFacing(GaranStuff.Cards.FaceDown); -- hides the suit and number
						Pile[tmpIndex].Bottom:SetVisible(false);
						CheckWin();
					end
					SelectedCards.Bottom:SetVisible(false);
					SelectedCards.Top:SetVisible(false);
					cardMoving=false;
				end
			end

			Pile[tmpIndex].Bottom.MouseMove=function(sender,args)
				if cardMoving then
					local left,top=SelectedCards.Top:GetPosition();
					if args.X~=SelectedCards.Top.X then
						left=SelectedCards.Top:GetLeft()-(SelectedCards.Top.X-args.X)
						SelectedCards.Top.X=args.X;
					end
					if args.Y~=SelectedCards.Top.Y then
						top=SelectedCards.Top:GetTop()-(SelectedCards.Top.Y-args.Y)
						SelectedCards.Top.Y=args.Y;
					end
					SelectedCards.Top:SetPosition(left,top);
					SelectedCards.Bottom:SetPosition(SelectedCards.Top:GetLeft()-20,SelectedCards.Top:GetTop()-20);
					SelectedCards.Bottom:CheckPosition(args);
				end
			end
		end

		Chute.Left=Pile[1].Top:GetLeft()+100;
		Chute.Top=Pile[1].Top:GetTop()-200;

		self:SetPosition(Pile[1].Top:GetLeft()+100,Pile[1].Top:GetTop()+100);

		for tmpIndex=1,numSuits do
			Stack[tmpIndex]=Card();
			-- we adjust the center +20 since the Piles have to be as wide as they are high (to account for image rotation bugs) but the images are only 40 x 100
			Stack[tmpIndex]:SetPosition(tableX+math.cos(math.rad((tmpIndex-1)/numSuits*360+90))*95+20,tableY+math.sin(math.rad((tmpIndex-1)/numSuits*360+90))*95)
			Stack[tmpIndex].Cards={};
			Stack[tmpIndex].Number=0;
			Stack[tmpIndex].Suit=tmpIndex;
			Stack[tmpIndex].BackImage=Decks[deckName][Decks[deckName].Suits[tmpIndex]][2];
			Stack[tmpIndex].FaceImage=Decks[deckName][Decks[deckName].Suits[tmpIndex]][2];
			Stack[tmpIndex]:SetFacing(GaranStuff.Cards.FaceDown);
			Stack[tmpIndex]:SetVisible(true);

			Stack[tmpIndex]:SetAllowDrop(true);
			Stack[tmpIndex].MouseDoubleClick=function(sender,args)
				if args.Button==2 then
					debugWindow:SetVisible(true);
				end
			end
		end

		-- now create a shuffled table for the deck
		Hand={}
		math.randomseed(Turbine.Engine.GetGameTime());
		local maxPos=numSuits*9
		for tmpSuit=1,numSuits do
			for tmpNumber=1,9 do
				position=math.random(maxPos);
				while position>0 and Hand[position]~=nil do
					position=position-1;
				end
				if position==0 then
					position=1;
					while position<=maxPos and Hand[position]~=nil do
						position=position+1;
					end
				end
				if position==0 then
					-- houston, we've had a problem...
				else
					Hand[position]={tmpSuit,tmpNumber};
				end
			end
		end

		-- theoretically at this point we have a shuffled deck which we call Hand
		for tmpIndex=1,numPiles do
			-- put one card from Hand face up on each pile
			Pile[tmpIndex].Cards={{Hand[1][1],Hand[1][2]}};
			Pile[tmpIndex].Top.FaceImage=Decks[deckName].Cards[Hand[1][1]][Hand[1][2]];
			Pile[tmpIndex].Top.Suit=Hand[1][1];
			Pile[tmpIndex].Top.SuitIconImage=Decks[deckName][Decks[deckName].Suits[Hand[1][1]]][1];
			Pile[tmpIndex].Top.Number=Hand[1][2];
			Pile[tmpIndex].Top:SetFacing(GaranStuff.Cards.FaceUp);
			table.remove(Hand,1);
		end
		for tmpIndex=1,#Hand do
			Chute.AddCard(Hand[tmpIndex][1],Hand[tmpIndex][2]);
			Hand[tmpIndex]=nil;
		end
		Chute.FaceUpIndex=0;
		Hand=nil;
	end

	self.VisibleChanged=function()
		local tmpIndex;
		local isVisible=ringMain:IsVisible();
		for tmpIndex=1,#Stack do
			if Stack[tmpIndex]~=nil then
				Stack[tmpIndex]:SetVisible(isVisible);
			end
		end
		for tmpIndex=1,#Pile do
			if Pile[tmpIndex].Top~=nil then
				Pile[tmpIndex].Top:SetVisible(isVisible);
			end
		end
		if Chute~=nil then
			for tmpIndex=1,#Chute do
				if Chute[tmpIndex]~=nil then
					Chute[tmpIndex]:SetVisible(isVisible);
				end
			end
		end
	end

	self.KeyDown=function(sender, args)
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			ringMain:SetVisible(false);
			ringMain.StatsWindow:SetVisible(false);
			ringMain.RulesWindow:SetVisible(false);
		end
		if ( args.Action == 268435635 ) then -- toggle HUD
			RingHUDState = not RingHUDState;
			if RingHUDState then
				ringMain:SetVisible(RingState);
				ringMain.StatsWindow:SetVisible(StatsState);
				ringMain.RulesWindow:SetVisible(RulesState);
				ringMain.StatsWindow:Refresh();
			else
				StatsState=ringMain.StatsWindow:IsVisible();
				RulesState=ringMain.RulesWindow:IsVisible();
				RingState=ringMain:IsVisible();
				ringMain:SetVisible(false);
				ringMain.StatsWindow:SetVisible(false);
				ringMain.RulesWindow:SetVisible(false);
			end
		end
	end

	self.shellCmd=Turbine.ShellCommand();
	local numberOfCommandsRegistered = Turbine.Shell.AddCommand("RingGame",self.shellCmd);

	self.shellCmd.Execute = function(sender, cmd, args)
		if (string.lower(cmd) == "ringgame") then
			local pos1=string.find(args," ",0,true);
			local command;
			if pos1~=nil and pos1>0 then
				command=string.lower(string.sub(args,1,pos1-1));
			else
				command=string.lower(args);
			end

			if (command=="show") then
				ringMain:SetVisible(true);
			elseif (command=="hide") then
				ringMain:SetVisible(false);
			elseif (command=="toggle") then
				ringMain:SetVisible(not ringMain:IsVisible());
			elseif (command=="deal") then
				local argArray=string.split(string.sub(args,pos1+1),",");
				ringMain.DealCards(tonumber(argArray[1]),tonumber(argArray[2]));
			elseif (command=="debug") then
				debugWindow:SetVisible(true);
			else
				Turbine.Shell.WriteLine("usage:");
				Turbine.Shell.WriteLine("  /RingGame show");
				Turbine.Shell.WriteLine("       Displays the Ring game.");
				Turbine.Shell.WriteLine("  /RingGame hide");
				Turbine.Shell.WriteLine("       Hides the Ring game.");
				Turbine.Shell.WriteLine("  /RingGame toggle");
				Turbine.Shell.WriteLine("       Toggles the Ring game (shows it if it was hidden, hides it if it was showing).");
			end
		end
	end

	self.shellCmd.GetHelp = function(sender, cmd)
		return("usage:\n  /RingGame show\n       Displays the Ring game.\n  /RingGame hide\n       Hides the Ring game.\n  /RingGame toggle\n       Toggles the Ring game (shows it if it was hidden, hides it if it was showing).");
	end

	self.shellCmd.GetShortHelp = function(sender, cmd)
		return("RingGame - usage: /RingGame show | hide | toggle");
	end
	self.SaveData=function()

		local Settings={};
		Settings[#Settings+1]={"DeckName",deckName};
		Settings[#Settings+1]={"SizeMult",sizeMult};
		Settings[#Settings+1]={"TableX",tableX};
		Settings[#Settings+1]={"TableY",tableY};

		PatchDataSave( Turbine.DataScope.Account, "Ring_Settings", Settings );
		PatchDataSave( Turbine.DataScope.Account, "Ring_Decks", Decks );
		PatchDataSave( Turbine.DataScope.Account, "Ring_Stats", Stats );
	end
	self.Unload=function()
		self.SaveData();
		Turbine.Shell.RemoveCommand(ringMain.shellCmd)
	end
	self.SetLanguage=function()
		self:SetText(Resource[language][3]);
		self.DeckCaption:SetText(Resource[language][12]..":");
		self.PilesCaption:SetText(Resource[language][7].." (3-9):");
		self.SuitsCaption:SetText(Resource[language][8].." (2-5):");
		self.CheatButton:SetText(Resource[language][26]);
		self.MenuButton:SetText(Resource[language][11]);
		self.StatsButton:SetText(Resource[language][27]);
		self.DealButton:SetText(Resource[language][9]);
		self.RulesButton:SetText(Resource[language][28]);
		self.DeckSelect.ListData:GetItem(1):SetText(Resource[language][13]);
		if self.DeckSelect:GetSelectedIndex()==1 then
			self.DeckSelect.CurrentValue:SetText(Resource[language][13]);
		end
		if self.StatsWindow.ToggleButton.State=="Grid" then
			self.StatsWindow.ToggleButton:SetText(Resource[language][29]);
		else
			self.StatsWindow.ToggleButton:SetText(Resource[language][30]);
		end
		self.StatsWindow.HeaderRow.pile:SetText(Resource[language][31]);
		self.StatsWindow.HeaderRow.suit:SetText(Resource[language][32]);
		self.StatsWindow.HeaderRow.played:SetText(Resource[language][33]);
		self.StatsWindow.GraphButtons.Choices[1].Caption:SetText(Resource[language][33])
		self.StatsWindow.GraphButtons.Choices[2].Caption:SetText(Resource[language][34])
		self.StatsWindow.GraphButtons.Choices[3].Caption:SetText(Resource[language][35])
		self.StatsWindow.GraphButtons.Choices[4].Caption:SetText(Resource[language][36])
		self.StatsWindow.GraphButtons.Choices[5].Caption:SetText(Resource[language][37])

		self.RulesWindow:SetText(Resource[language][28]);
		self.RulesWindow.Text:SetText(Resource[language][38]);
		self.StatsWindow.TotalRow.pile:SetText(Resource[language][39]);
	end
	self.SetFontColor=function()
		self.DeckCaption:SetForeColor(fontColor);
		self.PilesCaption:SetForeColor(fontColor);
		self.SuitsCaption:SetForeColor(fontColor);
		self.CheatButton:SetForeColor(fontColor);
		self.MenuButton:SetForeColor(fontColor);
		self.StatsButton:SetForeColor(fontColor);
		self.DealButton:SetForeColor(fontColor);
		self.RulesButton:SetForeColor(fontColor);
		self.StatsWindow.ToggleButton:SetForeColor(fontColor);
		self.StatsWindow.GraphButtons:SetTextColor(fontColor);
	end
	self.SetTrimColor=function()
		self.DeckSelect:SetBorderColor(trimColor);
		self.StatsWindow.GraphButtons:SetBorderColor(trimColor);
	end
	self.SetBackColor=function()
		self.DeckSelect:SetBackColor(backColor);
		self.DeckSelect.CurrentValue:SetBackColor(backColor);
	end
	self.SetHeadingsColor=function()
		self.StatsWindow.YCaption:SetForeColor(headingsColor);
		local tmpCap=1;
		for tmpPile=3,9 do
			for tmpSuit=2,5 do
				self.StatsWindow.XCaption[tmpCap]:SetForeColor(headingsColor);
				tmpCap=tmpCap+1;
			end
		end
	end
	self.SetListTextColor=function()
		self.DeckSelect:SetTextColor(listTextColor);
	end
	self.SetVisible=function(sender,value)
		Turbine.UI.Lotro.Window.SetVisible(self,value);
		self.Backdrop:SetVisible(value);
	end
	self.Update=function(sender,args)
		if Celebrating then
			local tmpSuit;
			local tmpOrdinal;
			local tmpDone=true;
			if VictoryDeck==nil or #VictoryDeck==0 then
				VictoryDeck={};
				tmpDone=false;
				for tmpSuit=1,#Stack do
					VictoryDeck[tmpSuit]={};
					for tmpOrdinal=1,9 do
						VictoryDeck[tmpSuit][tmpOrdinal]=Card();
						VictoryDeck[tmpSuit][tmpOrdinal]:SetPosition(Stack[tmpSuit]:GetPosition());
						VictoryDeck[tmpSuit][tmpOrdinal].FaceImage=Decks[deckName].Cards[tmpSuit][tmpOrdinal];
						VictoryDeck[tmpSuit][tmpOrdinal].SuitIconImage=Decks[deckName][Decks[deckName].Suits[tmpSuit]][1];
						VictoryDeck[tmpSuit][tmpOrdinal].Suit=tmpSuit;
						VictoryDeck[tmpSuit][tmpOrdinal].Number=tmpOrdinal;
						VictoryDeck[tmpSuit][tmpOrdinal]:SetFacing(GaranStuff.Cards.FaceUp);
						VictoryDeck[tmpSuit][tmpOrdinal]:SetZOrder(sender:GetZOrder()+tmpOrdinal);
						VictoryDeck[tmpSuit][tmpOrdinal]:SetRotation({x=0,y=0,z=0});
						VictoryDeck[tmpSuit][tmpOrdinal]:SetVisible(true);
						VictoryDeck[tmpSuit][tmpOrdinal].Active=false;
					end
					Stack[tmpSuit]:SetVisible(false);
					VictoryDeck[tmpSuit][9].Active=true;
				end
			else
				local numStacks=#Stack
				for tmpSuit=1,#VictoryDeck do
					for tmpOrdinal=1,#VictoryDeck[tmpSuit] do
						if VictoryDeck[tmpSuit][tmpOrdinal]:IsVisible() and VictoryDeck[tmpSuit][tmpOrdinal].Active then
							tmpDone=false;
							local rot=VictoryDeck[tmpSuit][tmpOrdinal]:GetRotation().z;
							VictoryDeck[tmpSuit][tmpOrdinal]:SetPosition(tableX+math.cos(math.rad((tmpSuit-1)/numStacks*360+90+(tmpOrdinal*rot/10)))*(95+rot)+20,tableY+math.sin(math.rad((tmpSuit-1)/numStacks*360+90+(tmpOrdinal*rot/10)))*(95+rot))
							VictoryDeck[tmpSuit][tmpOrdinal]:SetRotation({x=0,y=0,z=rot+10})
							if rot>60 and tmpOrdinal>1 then
								VictoryDeck[tmpSuit][tmpOrdinal-1].Active=true;
							end
							if rot>=360 then
								VictoryDeck[tmpSuit][tmpOrdinal]:SetVisible(false);
							end
						end
					end
				end
			end
			if tmpDone then
				-- clean up the "victory deck"
				for tmpSuit=1,#VictoryDeck do
					for tmpOrdinal=1,#VictoryDeck[tmpSuit] do
						VictoryDeck[tmpSuit][tmpOrdinal]=nil;
					end
					VictoryDeck[tmpSuit]=nil;
				end
				VictoryDeck={};
				Celebrating=false;
				self:SetWantsUpdates( false );
				-- move the main window back to the center
				ringMain:SetPosition((Turbine.UI.Display:GetWidth()-self:GetHeight())/2,(Turbine.UI.Display:GetHeight()-self:GetHeight())/2)
			end
		end
	end
	self.StatsWindow=Turbine.UI.Lotro.Window();
	self.StatsWindow:SetText(Resource[language][27]);
	self.StatsWindow:SetSize(940,525);
	self.StatsWindow:SetPosition((Turbine.UI.Display:GetWidth()-self.StatsWindow:GetWidth())/2,(Turbine.UI.Display:GetHeight()-self.StatsWindow:GetHeight())/2);
	self.StatsWindow:SetZOrder(self:GetZOrder()+46);
	self.StatsWindow.ToggleButton=Turbine.UI.Lotro.Button();
	self.StatsWindow.ToggleButton:SetParent(self.StatsWindow);
	self.StatsWindow.ToggleButton:SetSize(100,20);
	self.StatsWindow.ToggleButton:SetPosition(10,40);
	self.StatsWindow.ToggleButton:SetForeColor(fontColor);
	self.StatsWindow.ToggleButton:SetText(Resource[language][29]);
	self.StatsWindow.ToggleButton.State="Grid";
	self.StatsWindow.ToggleButton.MouseClick=function()
		if self.StatsWindow.ToggleButton.State=="Grid" then
			self.StatsWindow.ToggleButton.State="Graph"
			self.StatsWindow.GridTab:SetVisible(false);
			self.StatsWindow.GraphTab:SetVisible(true);
			self.StatsWindow.ToggleButton:SetText(Resource[language][30]);
		else
			self.StatsWindow.ToggleButton.State="Grid"
			self.StatsWindow.GridTab:SetVisible(true);
			self.StatsWindow.RefreshGrid();
			self.StatsWindow.GraphTab:SetVisible(false);
			self.StatsWindow.ToggleButton:SetText(Resource[language][29]);
		end
		self.StatsWindow:Refresh()
	end
	self.StatsWindow.Refresh=function()
		local tmpIndex;
		for tmpIndex=1,#self.StatsWindow.Lines do
			self.StatsWindow.Lines[tmpIndex]:Refresh()
		end
		self.StatsWindow:SetRotation({x=0,y=0,z=0}); -- there is a glitch in SetRotation that propagates the rotation to the parent control so we reset the parent to correct
	end
	self.StatsWindow.GridTab=Turbine.UI.Control();
	self.StatsWindow.GridTab:SetParent(self.StatsWindow);
	self.StatsWindow.GridTab:SetSize(self.StatsWindow:GetWidth()-10,self.StatsWindow:GetHeight()-90);
	self.StatsWindow.GridTab:SetPosition(5,60);
	self.StatsWindow.GridTab:SetVisible(true);

	self.StatsWindow.GraphTab=Turbine.UI.Control();
	self.StatsWindow.GraphTab:SetParent(self.StatsWindow);
	self.StatsWindow.GraphTab:SetSize(self.StatsWindow:GetWidth()-10,self.StatsWindow:GetHeight()-90);
	self.StatsWindow.GraphTab:SetPosition(5,60);
	self.StatsWindow.GraphTab:SetVisible(false);
	self.StatsWindow.Lines={};
	self.StatsWindow.PointCaptions={};

	-- draw the grid
	self.StatsWindow.HeaderRow=Turbine.UI.Control();
	self.StatsWindow.HeaderRow:SetParent(self.StatsWindow.GridTab)
	self.StatsWindow.HeaderRow:SetSize(828,19);
	self.StatsWindow.HeaderRow:SetPosition(5,0)
	self.StatsWindow.HeaderRow:SetBackColor(Turbine.UI.Color(.8,.8,.8));
	self.StatsWindow.HeaderRow.pile=Turbine.UI.Label();
	self.StatsWindow.HeaderRow.pile:SetParent(self.StatsWindow.HeaderRow);
	self.StatsWindow.HeaderRow.pile:SetSize(60,self.StatsWindow.HeaderRow:GetHeight()-1);
	self.StatsWindow.HeaderRow.pile:SetBackColor(Turbine.UI.Color(.05,.05,.15));
	self.StatsWindow.HeaderRow.pile:SetForeColor(Turbine.UI.Color(.68,.62,.3));
	self.StatsWindow.HeaderRow.pile:SetPosition(1,1);
	self.StatsWindow.HeaderRow.pile:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	self.StatsWindow.HeaderRow.pile:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.StatsWindow.HeaderRow.pile:SetText(Resource[language][31]);
	self.StatsWindow.HeaderRow.suit=Turbine.UI.Label();
	self.StatsWindow.HeaderRow.suit:SetParent(self.StatsWindow.HeaderRow);
	self.StatsWindow.HeaderRow.suit:SetSize(60,self.StatsWindow.HeaderRow:GetHeight()-1);
	self.StatsWindow.HeaderRow.suit:SetBackColor(Turbine.UI.Color(.05,.05,.15));
	self.StatsWindow.HeaderRow.suit:SetForeColor(Turbine.UI.Color(.68,.62,.3));
	self.StatsWindow.HeaderRow.suit:SetPosition(62,1);
	self.StatsWindow.HeaderRow.suit:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	self.StatsWindow.HeaderRow.suit:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.StatsWindow.HeaderRow.suit:SetText(Resource[language][32]);
	self.StatsWindow.HeaderRow.played=Turbine.UI.Label();
	self.StatsWindow.HeaderRow.played:SetParent(self.StatsWindow.HeaderRow);
	self.StatsWindow.HeaderRow.played:SetSize(140,self.StatsWindow.HeaderRow:GetHeight()-1);
	self.StatsWindow.HeaderRow.played:SetBackColor(Turbine.UI.Color(.05,.05,.15));
	self.StatsWindow.HeaderRow.played:SetForeColor(Turbine.UI.Color(.68,.62,.3));
	self.StatsWindow.HeaderRow.played:SetPosition(123,1);
	self.StatsWindow.HeaderRow.played:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	self.StatsWindow.HeaderRow.played:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.StatsWindow.HeaderRow.played:SetText(Resource[language][33]);
	self.StatsWindow.HeaderRow.numwon=Turbine.UI.Label();
	self.StatsWindow.HeaderRow.numwon:SetParent(self.StatsWindow.HeaderRow);
	self.StatsWindow.HeaderRow.numwon:SetSize(140,self.StatsWindow.HeaderRow:GetHeight()-1);
	self.StatsWindow.HeaderRow.numwon:SetBackColor(Turbine.UI.Color(.05,.05,.15));
	self.StatsWindow.HeaderRow.numwon:SetForeColor(Turbine.UI.Color(.68,.62,.3));
	self.StatsWindow.HeaderRow.numwon:SetPosition(264,1);
	self.StatsWindow.HeaderRow.numwon:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	self.StatsWindow.HeaderRow.numwon:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.StatsWindow.HeaderRow.numwon:SetText(Resource[language][34]);
	self.StatsWindow.HeaderRow.perwon=Turbine.UI.Label();
	self.StatsWindow.HeaderRow.perwon:SetParent(self.StatsWindow.HeaderRow);
	self.StatsWindow.HeaderRow.perwon:SetSize(140,self.StatsWindow.HeaderRow:GetHeight()-1);
	self.StatsWindow.HeaderRow.perwon:SetBackColor(Turbine.UI.Color(.05,.05,.15));
	self.StatsWindow.HeaderRow.perwon:SetForeColor(Turbine.UI.Color(.68,.62,.3));
	self.StatsWindow.HeaderRow.perwon:SetPosition(405,1);
	self.StatsWindow.HeaderRow.perwon:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	self.StatsWindow.HeaderRow.perwon:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.StatsWindow.HeaderRow.perwon:SetText(Resource[language][35]);
	self.StatsWindow.HeaderRow.cheats=Turbine.UI.Label();
	self.StatsWindow.HeaderRow.cheats:SetParent(self.StatsWindow.HeaderRow);
	self.StatsWindow.HeaderRow.cheats:SetSize(140,self.StatsWindow.HeaderRow:GetHeight()-1);
	self.StatsWindow.HeaderRow.cheats:SetBackColor(Turbine.UI.Color(.05,.05,.15));
	self.StatsWindow.HeaderRow.cheats:SetForeColor(Turbine.UI.Color(.68,.62,.3));
	self.StatsWindow.HeaderRow.cheats:SetPosition(546,1);
	self.StatsWindow.HeaderRow.cheats:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	self.StatsWindow.HeaderRow.cheats:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.StatsWindow.HeaderRow.cheats:SetText(Resource[language][36]);
	self.StatsWindow.HeaderRow.time=Turbine.UI.Label();
	self.StatsWindow.HeaderRow.time:SetParent(self.StatsWindow.HeaderRow);
	self.StatsWindow.HeaderRow.time:SetSize(140,self.StatsWindow.HeaderRow:GetHeight()-1);
	self.StatsWindow.HeaderRow.time:SetBackColor(Turbine.UI.Color(.05,.05,.15));
	self.StatsWindow.HeaderRow.time:SetForeColor(Turbine.UI.Color(.68,.62,.3));
	self.StatsWindow.HeaderRow.time:SetPosition(687,1);
	self.StatsWindow.HeaderRow.time:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	self.StatsWindow.HeaderRow.time:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.StatsWindow.HeaderRow.time:SetText(Resource[language][37]);

	self.StatsWindow.TotalRow=Turbine.UI.Control();
	self.StatsWindow.TotalRow:SetParent(self.StatsWindow.GridTab)
	self.StatsWindow.TotalRow:SetSize(828,19);
	self.StatsWindow.TotalRow:SetPosition(5,20)
	self.StatsWindow.TotalRow:SetBackColor(Turbine.UI.Color(.8,.8,.8));
	self.StatsWindow.TotalRow.pile=Turbine.UI.Label();
	self.StatsWindow.TotalRow.pile:SetParent(self.StatsWindow.TotalRow);
	self.StatsWindow.TotalRow.pile:SetSize(121,self.StatsWindow.TotalRow:GetHeight()-1);
	self.StatsWindow.TotalRow.pile:SetBackColor(Turbine.UI.Color(.15,.10,.05));
	self.StatsWindow.TotalRow.pile:SetForeColor(Turbine.UI.Color(.68,.62,.3));
	self.StatsWindow.TotalRow.pile:SetPosition(1,1);
	self.StatsWindow.TotalRow.pile:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	self.StatsWindow.TotalRow.pile:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.StatsWindow.TotalRow.pile:SetText(Resource[language][39]);
	self.StatsWindow.TotalRow.played=Turbine.UI.Label();
	self.StatsWindow.TotalRow.played:SetParent(self.StatsWindow.TotalRow);
	self.StatsWindow.TotalRow.played:SetSize(140,self.StatsWindow.TotalRow:GetHeight()-1);
	self.StatsWindow.TotalRow.played:SetBackColor(Turbine.UI.Color(.15,.10,.05));
	self.StatsWindow.TotalRow.played:SetForeColor(Turbine.UI.Color(.68,.62,.3));
	self.StatsWindow.TotalRow.played:SetPosition(123,1);
	self.StatsWindow.TotalRow.played:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	self.StatsWindow.TotalRow.played:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.StatsWindow.TotalRow.numwon=Turbine.UI.Label();
	self.StatsWindow.TotalRow.numwon:SetParent(self.StatsWindow.TotalRow);
	self.StatsWindow.TotalRow.numwon:SetSize(140,self.StatsWindow.TotalRow:GetHeight()-1);
	self.StatsWindow.TotalRow.numwon:SetBackColor(Turbine.UI.Color(.15,.10,.05));
	self.StatsWindow.TotalRow.numwon:SetForeColor(Turbine.UI.Color(.68,.62,.3));
	self.StatsWindow.TotalRow.numwon:SetPosition(264,1);
	self.StatsWindow.TotalRow.numwon:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	self.StatsWindow.TotalRow.numwon:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.StatsWindow.TotalRow.perwon=Turbine.UI.Label();
	self.StatsWindow.TotalRow.perwon:SetParent(self.StatsWindow.TotalRow);
	self.StatsWindow.TotalRow.perwon:SetSize(140,self.StatsWindow.TotalRow:GetHeight()-1);
	self.StatsWindow.TotalRow.perwon:SetBackColor(Turbine.UI.Color(.15,.10,.05));
	self.StatsWindow.TotalRow.perwon:SetForeColor(Turbine.UI.Color(.68,.62,.3));
	self.StatsWindow.TotalRow.perwon:SetPosition(405,1);
	self.StatsWindow.TotalRow.perwon:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	self.StatsWindow.TotalRow.perwon:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.StatsWindow.TotalRow.cheats=Turbine.UI.Label();
	self.StatsWindow.TotalRow.cheats:SetParent(self.StatsWindow.TotalRow);
	self.StatsWindow.TotalRow.cheats:SetSize(140,self.StatsWindow.TotalRow:GetHeight()-1);
	self.StatsWindow.TotalRow.cheats:SetBackColor(Turbine.UI.Color(.15,.10,.05));
	self.StatsWindow.TotalRow.cheats:SetForeColor(Turbine.UI.Color(.68,.62,.3));
	self.StatsWindow.TotalRow.cheats:SetPosition(546,1);
	self.StatsWindow.TotalRow.cheats:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	self.StatsWindow.TotalRow.cheats:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.StatsWindow.TotalRow.time=Turbine.UI.Label();
	self.StatsWindow.TotalRow.time:SetParent(self.StatsWindow.TotalRow);
	self.StatsWindow.TotalRow.time:SetSize(140,self.StatsWindow.TotalRow:GetHeight()-1);
	self.StatsWindow.TotalRow.time:SetBackColor(Turbine.UI.Color(.15,.10,.05));
	self.StatsWindow.TotalRow.time:SetForeColor(Turbine.UI.Color(.68,.62,.3));
	self.StatsWindow.TotalRow.time:SetPosition(687,1);
	self.StatsWindow.TotalRow.time:SetFont(Turbine.UI.Lotro.Font.Verdana14)
	self.StatsWindow.TotalRow.time:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);

	self.StatsWindow.Grid=Turbine.UI.ListBox();
	self.StatsWindow.Grid:SetParent(self.StatsWindow.GridTab);
	self.StatsWindow.Grid:SetSize(828,self.StatsWindow.GridTab:GetHeight()-40);
	self.StatsWindow.Grid:SetPosition(5,39)

	self.StatsWindow.GridVScroll=Turbine.UI.Lotro.ScrollBar();
	self.StatsWindow.GridVScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
	self.StatsWindow.GridVScroll:SetParent(self.StatsWindow.GridTab);
	self.StatsWindow.GridVScroll:SetPosition(self.StatsWindow.Grid:GetLeft()+self.StatsWindow.Grid:GetWidth(),self.StatsWindow.Grid:GetTop());
	self.StatsWindow.GridVScroll:SetWidth(12);
	self.StatsWindow.GridVScroll:SetHeight(self.StatsWindow.Grid:GetHeight());
	self.StatsWindow.Grid:SetVerticalScrollBar(self.StatsWindow.GridVScroll);
	self.StatsWindow.GridVScroll:SetVisible(false);

	local row=Turbine.UI.Control();
	row:SetSize(self.StatsWindow.Grid:GetWidth(),1);
	row:SetBackColor(Turbine.UI.Color(.8,.8,.8));
	self.StatsWindow.Grid:AddItem(row);
	local tmpPile,tmpSuit;
	local backcolor=Turbine.UI.Color(0,0,0);
	for tmpPile=3,9 do
		for tmpSuit=2,5 do
			if backcolor.R==0 then
				backcolor=Turbine.UI.Color(.10,.10,.15);
			else
				backcolor=Turbine.UI.Color(0,0,0);
			end
			row=Turbine.UI.Control();
			row:SetSize(self.StatsWindow.Grid:GetWidth(),19);
			row:SetBackColor(Turbine.UI.Color(.8,.8,.8));
			row.pile=Turbine.UI.Label();
			row.pile:SetParent(row);
			row.pile:SetSize(60,row:GetHeight()-1);
			row.pile:SetBackColor(backcolor);
			row.pile:SetPosition(1,0);
			row.pile:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
			row.pile:SetText(tmpPile);
			row.suit=Turbine.UI.Label();
			row.suit:SetParent(row);
			row.suit:SetSize(60,row:GetHeight()-1);
			row.suit:SetBackColor(backcolor);
			row.suit:SetPosition(62,0);
			row.suit:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
			row.suit:SetText(tmpSuit);
			row.played=Turbine.UI.Label();
			row.played:SetParent(row);
			row.played:SetSize(140,row:GetHeight()-1);
			row.played:SetBackColor(backcolor);
			row.played:SetPosition(123,0);
			row.played:SetFont(Turbine.UI.Lotro.Font.Verdana14)
			row.played:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
			row.numwon=Turbine.UI.Label();
			row.numwon:SetParent(row);
			row.numwon:SetSize(140,row:GetHeight()-1);
			row.numwon:SetBackColor(backcolor);
			row.numwon:SetPosition(264,0);
			row.numwon:SetFont(Turbine.UI.Lotro.Font.Verdana14)
			row.numwon:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
			row.perwon=Turbine.UI.Label();
			row.perwon:SetParent(row);
			row.perwon:SetSize(140,row:GetHeight()-1);
			row.perwon:SetBackColor(backcolor);
			row.perwon:SetPosition(405,0);
			row.perwon:SetFont(Turbine.UI.Lotro.Font.Verdana14)
			row.perwon:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
			row.cheats=Turbine.UI.Label();
			row.cheats:SetParent(row);
			row.cheats:SetSize(140,row:GetHeight()-1);
			row.cheats:SetBackColor(backcolor);
			row.cheats:SetPosition(546,0);
			row.cheats:SetFont(Turbine.UI.Lotro.Font.Verdana14)
			row.cheats:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
			row.time=Turbine.UI.Label();
			row.time:SetParent(row);
			row.time:SetSize(140,row:GetHeight()-1);
			row.time:SetBackColor(backcolor);
			row.time:SetPosition(687,0);
			row.time:SetFont(Turbine.UI.Lotro.Font.Verdana14)
			row.time:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
			self.StatsWindow.Grid:AddItem(row);
		end
	end
	self.StatsWindow.RefreshGrid=function(sender)
		local tmpIndex=2;
		local tmpPlayed, tmpWon, tmpPer, tmpCheat, tmpTime;
		local tmpRow;
		local minutes,seconds;
		local totPlayed, totWon, totCheat, bestTime=0,0,0,0;
		for tmpPile=3,9 do
			for tmpSuit=2,5 do
				tmpPlayed="";
				tmpWon="";
				tmpPer="";
				tmpCheat="";
				tmpTime="";
				if Stats[tmpPile][tmpSuit]~=nil then
					if Stats[tmpPile][tmpSuit].GamesPlayed~=nil then
						if Stats[tmpPile][tmpSuit].GamesPlayed>0 then
							totPlayed=totPlayed+Stats[tmpPile][tmpSuit].GamesPlayed;
							tmpPlayed=tostring(Stats[tmpPile][tmpSuit].GamesPlayed);
							tmpWon="0";
							tmpPer="0";
							if Stats[tmpPile][tmpSuit].GamesWon~=nil then
								totWon=totWon+Stats[tmpPile][tmpSuit].GamesWon
								tmpWon=tostring(Stats[tmpPile][tmpSuit].GamesWon);
								tmpPer=tostring(math.floor(Stats[tmpPile][tmpSuit].GamesWon/Stats[tmpPile][tmpSuit].GamesPlayed*100+.5));
							end
							if Stats[tmpPile][tmpSuit].TimesCheat~=nil then
								totCheat=totCheat+Stats[tmpPile][tmpSuit].TimesCheat;
								tmpCheat=tostring(Stats[tmpPile][tmpSuit].TimesCheat);
							end
							if Stats[tmpPile][tmpSuit].BestTime~=nil then
								if bestTime==0 or Stats[tmpPile][tmpSuit].BestTime<bestTime then
									bestTime=Stats[tmpPile][tmpSuit].BestTime;
								end
								seconds=Stats[tmpPile][tmpSuit].BestTime;
								minutes=math.floor(seconds/60);
								seconds=seconds-minutes*60;
								if seconds<10 then
									tmpTime=tostring(minutes)..":0"..tostring(seconds);
								else
									tmpTime=tostring(minutes)..":"..tostring(seconds);
								end
							end
						end
					end
				end
				tmpRow=self.StatsWindow.Grid:GetItem(tmpIndex);

				tmpRow.played:SetText(tmpPlayed);
				tmpRow.numwon:SetText(tmpWon);
				tmpRow.perwon:SetText(tmpPer);
				tmpRow.cheats:SetText(tmpCheat);
				tmpRow.time:SetText(tmpTime);
				tmpIndex=tmpIndex+1
			end
		end
		self.StatsWindow.TotalRow.played:SetText(totPlayed);
		self.StatsWindow.TotalRow.numwon:SetText(totWon);
		if totPlayed>0 then
			self.StatsWindow.TotalRow.perwon:SetText(math.floor(totWon/totPlayed*100+.5));
		else
			self.StatsWindow.TotalRow.perwon:SetText("");
		end
		self.StatsWindow.TotalRow.cheats:SetText(totCheats);
		minutes=math.floor(bestTime/60);
		seconds=bestTime-minutes*60;
		if seconds<10 then
			self.StatsWindow.TotalRow.time:SetText(tostring(minutes)..":0"..tostring(seconds));
		else
			self.StatsWindow.TotalRow.time:SetText(tostring(minutes)..":"..tostring(seconds));
		end
	end

	-- draw the graph	
	self.StatsWindow.YAxis=Turbine.UI.Control();
	self.StatsWindow.YAxis:SetParent(self.StatsWindow.GraphTab);
	self.StatsWindow.YAxis:SetBackColor(Turbine.UI.Color(1,1,1));
	self.StatsWindow.YAxis:SetSize(1,self.StatsWindow.GraphTab:GetHeight()-40);
	self.StatsWindow.YAxis:SetPosition(40,0);

	self.StatsWindow.XAxis=Turbine.UI.Control();
	self.StatsWindow.XAxis:SetParent(self.StatsWindow.GraphTab);
	self.StatsWindow.XAxis:SetBackColor(Turbine.UI.Color(1,1,1));
	self.StatsWindow.XAxis:SetSize(self.StatsWindow.GraphTab:GetWidth()-40,1);
	self.StatsWindow.XAxis:SetPosition(40,self.StatsWindow.GraphTab:GetHeight()-40);

	self.StatsWindow.GraphPane=Turbine.UI.Control();
	self.StatsWindow.GraphPane:SetParent(self.StatsWindow.GraphTab);
	self.StatsWindow.GraphPane:SetSize(self.StatsWindow.GraphTab:GetWidth()-41,self.StatsWindow.GraphTab:GetHeight()-41);
	self.StatsWindow.GraphPane:SetPosition(41,0);

	self.StatsWindow.GraphButtons=RadioButtonGroup();
	self.StatsWindow.GraphButtons:SetParent(self.StatsWindow.GraphTab);
	self.StatsWindow.GraphButtons.RowHeight=18;
	self.StatsWindow.GraphButtons:SetSize(self.StatsWindow.GraphTab:GetWidth()-40,20);
	self.StatsWindow.GraphButtons:SetPosition(40,self.StatsWindow.GraphTab:GetHeight()-21);
	self.StatsWindow.GraphButtons.IconWidth=16;
	self.StatsWindow.GraphButtons.IconHeight=16;
	self.StatsWindow.GraphButtons.UnselectedIcon="GaranStuff/Cards/Resources/RB_unselected.tga";
	self.StatsWindow.GraphButtons.SelectedIcon="GaranStuff/Cards/Resources/RB_selected.tga";
	self.StatsWindow.GraphButtons:SetTextColor(fontColor);
	self.StatsWindow.GraphButtons:SetBorderColor(trimColor);

	self.StatsWindow.GraphButtons.SelectionChanged=function()
		local graph=self.StatsWindow.GraphButtons:GetSelectedChoice();
		self.StatsWindow:RefreshGraph(graph);
	end

	self.StatsWindow.GraphButtons:AddChoice(Resource[language][33]);
	self.StatsWindow.GraphButtons:AddChoice(Resource[language][34]);
	self.StatsWindow.GraphButtons:AddChoice(Resource[language][35]);
	self.StatsWindow.GraphButtons:AddChoice(Resource[language][36]);
	self.StatsWindow.GraphButtons:AddChoice(Resource[language][37]);

	self.StatsWindow.YCaption=Turbine.UI.Label()
	self.StatsWindow.YCaption:SetParent(self.StatsWindow.GraphTab);
	self.StatsWindow.YCaption:SetSize(39,20);
	self.StatsWindow.YCaption:SetPosition(0,5);
	self.StatsWindow.YCaption:SetForeColor(headingsColor);
	self.StatsWindow.YCaption:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight );

	self.StatsWindow.XCaption={}
	local tmpCap=1;
	for tmpPile=3,9 do
		for tmpSuit=2,5 do
			self.StatsWindow.XCaption[tmpCap]=Turbine.UI.Label()
			self.StatsWindow.XCaption[tmpCap]:SetParent(self.StatsWindow.GraphTab);
			self.StatsWindow.XCaption[tmpCap]:SetSize(30,20);
			self.StatsWindow.XCaption[tmpCap]:SetPosition(tmpCap*30+15,self.StatsWindow.GraphTab:GetHeight()-40);
			self.StatsWindow.XCaption[tmpCap]:SetForeColor(headingsColor);
			self.StatsWindow.XCaption[tmpCap]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter );
			self.StatsWindow.XCaption[tmpCap]:SetText(tostring(tmpPile)..","..tostring(tmpSuit));
			tmpCap=tmpCap+1;
		end
	end

	self.StatsWindow.RefreshGraph=function(sender,graph)
		local tmpPile,tmpSuit
		-- clear all current lines
		while #self.StatsWindow.Lines>0 do
			self.StatsWindow.Lines[1]:SetVisible(false);
			self.StatsWindow.Lines[1]=nil;
			table.remove(self.StatsWindow.Lines,1)
			self.StatsWindow.PointCaptions[1]:SetVisible(false);
			self.StatsWindow.PointCaptions[1]=nil;
			table.remove(self.StatsWindow.PointCaptions,1)
		end
		self.StatsWindow.Lines={};
		self.StatsWindow.PointCaptions={};
		-- force a garbage collect to clear the graphical schmegma
		collectgarbage("collect");
		if graph==1 then
			local maxval=0;
			local maxheight=self.StatsWindow.GraphPane:GetHeight()-20;
			local x,y,y1=0,maxheight+20,0;
			local points=0;
			for tmpPile=3,9 do
				for tmpSuit=2,5 do
					if Stats[tmpPile][tmpSuit]~=nil and Stats[tmpPile][tmpSuit].GamesPlayed~=nil then
						if Stats[tmpPile][tmpSuit].GamesPlayed>maxval then maxval=Stats[tmpPile][tmpSuit].GamesPlayed end
					end
				end
			end
			for tmpPile=3,9 do
				for tmpSuit=2,5 do
					if Stats[tmpPile][tmpSuit]~=nil then
						local val=Stats[tmpPile][tmpSuit].GamesPlayed
						if val==nil then val=0 end
						-- add this datapoint and a line from prior data point to this one
						points=points+1
						y1=maxheight-val/maxval*maxheight+20;
						self.StatsWindow.Lines[points]=Line(x,y,x+30,y1,2,Turbine.UI.Color(.4,.4,1));
						self.StatsWindow.Lines[points]:SetParent(self.StatsWindow.GraphPane);
						self.StatsWindow.PointCaptions[points]=Turbine.UI.Label();
						self.StatsWindow.PointCaptions[points]:SetParent(self.StatsWindow.GraphPane);
						self.StatsWindow.PointCaptions[points]:SetSize(50,20);
						self.StatsWindow.PointCaptions[points]:SetPosition(x+4,y1-15);
						self.StatsWindow.PointCaptions[points]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter );
						if val>0 then
							self.StatsWindow.PointCaptions[points]:SetText(val);
						else
							self.StatsWindow.PointCaptions[points]:SetText("");
						end
						self.StatsWindow.PointCaptions[points]:SetZOrder(1);
						x=x+30
						y=y1;
					end
				end
			end
			self.StatsWindow.YCaption:SetText(tostring(maxval));		
		elseif graph==2 then
			local maxval=0;
			local maxheight=self.StatsWindow.GraphPane:GetHeight()-20;
			local x,y,y1=0,maxheight+20,0;
			local points=0;
			for tmpPile=3,9 do
				for tmpSuit=2,5 do
					if Stats[tmpPile][tmpSuit]~=nil and Stats[tmpPile][tmpSuit].GamesWon~=nil then
						if Stats[tmpPile][tmpSuit].GamesWon>maxval then maxval=Stats[tmpPile][tmpSuit].GamesWon end
					end
				end
			end
			for tmpPile=3,9 do
				for tmpSuit=2,5 do
					if Stats[tmpPile][tmpSuit]~=nil then
						local val=Stats[tmpPile][tmpSuit].GamesWon
						if val==nil then val=0 end
						-- add this datapoint and a line from prior data point to this one
						points=points+1
						y1=maxheight-val/maxval*maxheight+20;
						self.StatsWindow.Lines[points]=Line(x,y,x+30,y1,2,Turbine.UI.Color(.4,.4,1));
						self.StatsWindow.Lines[points]:SetParent(self.StatsWindow.GraphPane);
						self.StatsWindow.PointCaptions[points]=Turbine.UI.Label();
						self.StatsWindow.PointCaptions[points]:SetParent(self.StatsWindow.GraphPane);
						self.StatsWindow.PointCaptions[points]:SetSize(50,20);
						self.StatsWindow.PointCaptions[points]:SetPosition(x+4,y1-15);
						self.StatsWindow.PointCaptions[points]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter );
						if val>0 then
							self.StatsWindow.PointCaptions[points]:SetText(val);
						else
							self.StatsWindow.PointCaptions[points]:SetText("");
						end
						self.StatsWindow.PointCaptions[points]:SetZOrder(1);
						x=x+30
						y=y1;
					end
				end
			end
			self.StatsWindow.YCaption:SetText(tostring(maxval));		
		elseif graph==3 then
			local maxval=0;
			local maxheight=self.StatsWindow.GraphPane:GetHeight()-20;
			local x,y,y1=0,maxheight+20,0;
			local points=0;
			for tmpPile=3,9 do
				for tmpSuit=2,5 do
					if Stats[tmpPile][tmpSuit]~=nil and Stats[tmpPile][tmpSuit].GamesPlayed~=nil and Stats[tmpPile][tmpSuit].GamesWon~=nil and Stats[tmpPile][tmpSuit].GamesPlayed>0 then
						if math.floor(Stats[tmpPile][tmpSuit].GamesWon/Stats[tmpPile][tmpSuit].GamesPlayed*100+.5)>maxval then maxval=math.floor(Stats[tmpPile][tmpSuit].GamesWon/Stats[tmpPile][tmpSuit].GamesPlayed*100) end
					end
				end
			end
			for tmpPile=3,9 do
				for tmpSuit=2,5 do
					if Stats[tmpPile][tmpSuit]~=nil then
						local val=0;
						if Stats[tmpPile][tmpSuit].GamesPlayed~=nil and Stats[tmpPile][tmpSuit].GamesWon~=nil and Stats[tmpPile][tmpSuit].GamesPlayed>0 then
							val=math.floor(Stats[tmpPile][tmpSuit].GamesWon/Stats[tmpPile][tmpSuit].GamesPlayed*100+.5)
						end
						-- add this datapoint and a line from prior data point to this one
						points=points+1
						y1=maxheight-val/maxval*maxheight+20;
						self.StatsWindow.Lines[points]=Line(x,y,x+30,y1,2,Turbine.UI.Color(.4,.4,1));
						self.StatsWindow.Lines[points]:SetParent(self.StatsWindow.GraphPane);
						self.StatsWindow.PointCaptions[points]=Turbine.UI.Label();
						self.StatsWindow.PointCaptions[points]:SetParent(self.StatsWindow.GraphPane);
						self.StatsWindow.PointCaptions[points]:SetSize(50,20);
						self.StatsWindow.PointCaptions[points]:SetPosition(x+4,y1-15);
						self.StatsWindow.PointCaptions[points]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter );
						if val>0 then
							self.StatsWindow.PointCaptions[points]:SetText(val);
						else
							self.StatsWindow.PointCaptions[points]:SetText("");
						end
						self.StatsWindow.PointCaptions[points]:SetZOrder(1);
						x=x+30
						y=y1;
					end
				end
			end
			self.StatsWindow.YCaption:SetText(tostring(maxval));		
		elseif graph==4 then
			local maxval=0;
			local maxheight=self.StatsWindow.GraphPane:GetHeight()-20;
			local x,y,y1=0,maxheight+20,0;
			local points=0;
			for tmpPile=3,9 do
				for tmpSuit=2,5 do
					if Stats[tmpPile][tmpSuit]~=nil and Stats[tmpPile][tmpSuit].TimesCheat~=nil then
						if Stats[tmpPile][tmpSuit].TimesCheat>maxval then maxval=Stats[tmpPile][tmpSuit].TimesCheat end
					end
				end
			end
			for tmpPile=3,9 do
				for tmpSuit=2,5 do
					if Stats[tmpPile][tmpSuit]~=nil then
						local val=Stats[tmpPile][tmpSuit].TimesCheat
						if val==nil then val=0 end
						-- add this datapoint and a line from prior data point to this one
						points=points+1
						y1=maxheight-val/maxval*maxheight+20;
						self.StatsWindow.Lines[points]=Line(x,y,x+30,y1,2,Turbine.UI.Color(.4,.4,1));
						self.StatsWindow.Lines[points]:SetParent(self.StatsWindow.GraphPane);
						self.StatsWindow.PointCaptions[points]=Turbine.UI.Label();
						self.StatsWindow.PointCaptions[points]:SetParent(self.StatsWindow.GraphPane);
						self.StatsWindow.PointCaptions[points]:SetSize(50,20);
						self.StatsWindow.PointCaptions[points]:SetPosition(x+4,y1-15);
						self.StatsWindow.PointCaptions[points]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter );
						if val>0 then
							self.StatsWindow.PointCaptions[points]:SetText(val);
						else
							self.StatsWindow.PointCaptions[points]:SetText("");
						end
						self.StatsWindow.PointCaptions[points]:SetZOrder(1);
						x=x+30
						y=y1;
					end
				end
			end
			self.StatsWindow.YCaption:SetText(tostring(maxval));		
		elseif graph==5 then
			local worst=0;
			local best=0;
			local maxheight=self.StatsWindow.GraphPane:GetHeight()-20;
			local x,y,y1=0,maxheight+20,0;
			local points=0;
			local minutes,seconds;
			for tmpPile=3,9 do
				for tmpSuit=2,5 do
					if Stats[tmpPile][tmpSuit]~=nil and Stats[tmpPile][tmpSuit].BestTime~=nil then
						if Stats[tmpPile][tmpSuit].BestTime>worst then
							worst=Stats[tmpPile][tmpSuit].BestTime;
						end
						if best==0 or Stats[tmpPile][tmpSuit].BestTime<best then
							best=Stats[tmpPile][tmpSuit].BestTime
						end
					end
				end
			end
			for tmpPile=3,9 do
				for tmpSuit=2,5 do
					if Stats[tmpPile][tmpSuit]~=nil then
						local val=Stats[tmpPile][tmpSuit].BestTime
						if val==nil then val=0 end
						-- add this datapoint and a line from prior data point to this one
						points=points+1
						y1=maxheight-val/worst*maxheight+20;
						self.StatsWindow.Lines[points]=Line(x,y,x+30,y1,2,Turbine.UI.Color(.4,.4,1));
						self.StatsWindow.Lines[points]:SetParent(self.StatsWindow.GraphPane);
						self.StatsWindow.PointCaptions[points]=Turbine.UI.Label();
						self.StatsWindow.PointCaptions[points]:SetParent(self.StatsWindow.GraphPane);
						self.StatsWindow.PointCaptions[points]:SetSize(50,20);
						self.StatsWindow.PointCaptions[points]:SetPosition(x+4,y1-15);
						self.StatsWindow.PointCaptions[points]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter );
						if val>0 then
							minutes=math.floor(val/60)
							seconds=val-minutes*60
							if seconds<10 then
								self.StatsWindow.PointCaptions[points]:SetText(tostring(minutes)..":0"..tostring(seconds));
							else
								self.StatsWindow.PointCaptions[points]:SetText(tostring(minutes)..":"..tostring(seconds));
							end
						else
							self.StatsWindow.PointCaptions[points]:SetText("");
						end
						self.StatsWindow.PointCaptions[points]:SetZOrder(1);
						x=x+30
						y=y1;
					end
				end
			end
			minutes=math.floor(worst/60)
			seconds=worst-minutes*60
			if seconds<10 then
				self.StatsWindow.YCaption:SetText(tostring(minutes)..":0"..tostring(seconds));
			else
				self.StatsWindow.YCaption:SetText(tostring(minutes)..":"..tostring(seconds));
			end
			-- draw a line and an additional point caption for the best time
			points=points+1
			y=maxheight-best/worst*maxheight+20;
			self.StatsWindow.Lines[points]=Line(40,y,self.StatsWindow.GraphTab:GetWidth(),y,2,Turbine.UI.Color(.4,1,.4));
			self.StatsWindow.Lines[points]:SetParent(self.StatsWindow.GraphTab);
			self.StatsWindow.PointCaptions[points]=Turbine.UI.Label();
			self.StatsWindow.PointCaptions[points]:SetParent(self.StatsWindow.GraphTab);
			self.StatsWindow.PointCaptions[points]:SetSize(39,20);
			self.StatsWindow.PointCaptions[points]:SetPosition(0,y-10);
			self.StatsWindow.PointCaptions[points]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight );
			minutes=math.floor(best/60)
			seconds=best-minutes*60
			if seconds<10 then
				self.StatsWindow.PointCaptions[points]:SetText(tostring(minutes)..":0"..tostring(seconds));
			else
				self.StatsWindow.PointCaptions[points]:SetText(tostring(minutes)..":"..tostring(seconds));
			end
			self.StatsWindow.PointCaptions[points]:SetZOrder(1);
		end
	end

	self.StatsWindow.RefreshGrid();
	self.StatsWindow.GraphButtons:SetSelectedChoice(1);

	self.StatsWindow:SetVisible(false);
	self.RulesWindow=Turbine.UI.Lotro.Window();
	self.RulesWindow:SetSize(640,480);
	self.RulesWindow:SetPosition((Turbine.UI.Display:GetWidth()-self.RulesWindow:GetWidth())/2,(Turbine.UI.Display:GetHeight()-self.RulesWindow:GetHeight())/2);
	self.RulesWindow:SetText(Resource[language][28]);
	self.RulesWindow.Text=Turbine.UI.Label();
	self.RulesWindow.Text:SetParent(self.RulesWindow);
	self.RulesWindow.Text:SetSize(self.RulesWindow:GetWidth()-42,self.RulesWindow:GetHeight()-80);
	self.RulesWindow.Text:SetPosition(15,40);
	self.RulesWindow.Text:SetText(Resource[language][38]);
	self.RulesWindow:SetZOrder(self:GetZOrder()+46); -- force it to be in front of the chute

	self.RulesWindow.VScroll=Turbine.UI.Lotro.ScrollBar();
	self.RulesWindow.VScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
	self.RulesWindow.VScroll:SetParent(self.RulesWindow);
	self.RulesWindow.VScroll:SetPosition(self.RulesWindow.Text:GetLeft()+self.RulesWindow.Text:GetWidth(),self.RulesWindow.Text:GetTop());
	self.RulesWindow.VScroll:SetWidth(12);
	self.RulesWindow.VScroll:SetHeight(self.RulesWindow.Text:GetHeight());
	self.RulesWindow.Text:SetVerticalScrollBar(self.RulesWindow.VScroll);
	self.RulesWindow.VScroll:SetVisible(false);
end
